/*
 *$Id: logger.h,v 1.6 2001/09/12 21:32:32 mulix Exp $
 */
/* This is a skeletal logging interface and implementation
 * @author: mulix@actcom.co.il
 */

#ifndef _LOGGER_H_
#define _LOGGER_H_

using namespace std;

#include <string>
#include <iostream>

class logger
{
 public:
    typedef enum {
	LOG_LEVEL_DEBUG = 0,
	LOG_LEVEL_INFO,
	LOG_LEVEL_WARNING,
	LOG_LEVEL_ERROR
    } verbosity_level_t;

    static void log(verbosity_level_t vl, const string& msg);
    static void log(verbosity_level_t vl, const char* fmt, ...);
    static void use_syslog(bool use_syslog){_use_syslog = use_syslog;}
    static void set_verbosity_level(verbosity_level_t vl){_verbosity_level = vl;}
    static verbosity_level_t get_verbosity_level(){return _verbosity_level;}

 private:
    static bool _use_syslog;
    static verbosity_level_t _verbosity_level;
    static void open_syslog(const char* name);
    static void close_syslog();
    static void do_log(const char* buf);
};

#endif //_LOGGER_H_
