/*
 *$Id: process_conditional.h,v 1.8 2001/10/12 21:36:21 mulix Exp $
 */
/* This is the a condition which is based upon the process which is 
 * executing the system call
 * @author: mulix@actcom.co.il
 */

#ifndef _PROCESS_CONDITIONAL_H_
#define _PROCESS_CONDITIONAL_H_

#include <iostream>
#include <string>

#include "conditional.h"
#include "param_types.h"

class process_conditional: public conditional
{
 public:
    process_conditional(const parser& p);
    ~process_conditional();
    process_conditional(const process_conditional& rhs); 

    bool validate(const string& sysname);

    void set_process_field(const string& str);
    process_field_t get_process_field() const;

    filter_node_t* get_filter_node(void) const;

    ostream& print(ostream& os);

    bool finalize(const string& sys_name);

 protected:
    data_type_t query_required_data_type(const string& sys_name);
    
 private:
    process_field_t _proc_field;
};

#endif //_PARAM_CONDITIONAL_H_
