/*
 * $Id: dev_file_impl.h,v 1.4 2001/12/09 19:55:06 chooga Exp $
 */ 

#ifndef DEV_FILE_IMPL_H_
#define DEV_FILE_IMPL_H_

/* this file implements the device file communication protocol between
   the kernel module and userspace. for protocol details, see 
   doc/sct_device_control_file_design.txt */

#include "sct_ctrl_lib.h"

/* add rule */
int 
dev_file_add_rule(sct_ctrl_t ctrl,
		  int rule_id,
		  rule_when_t when,
		  int syscall_id, 
		  filter_node_t* filter, action_t* act,
		  int enable_rule);

/* delete a rule */
int
dev_file_del_rule(sct_ctrl_t ctrl,
		  int rule_id,
		  rule_when_t when,
		  int syscall_id);

/* enable a rule */
int 
dev_file_enable_rule(sct_ctrl_t ctrl,
		     int rule_id,
		     rule_when_t when,
		     int syscall_id);

/* disable a rule */
int 
dev_file_disable_rule(sct_ctrl_t ctrl,
		      int rule_id,
		      rule_when_t when,
		      int syscall_id);

/* delete all rules for this syscall */
int 
dev_file_del_all_syscall_rules(sct_ctrl_t ctrl, int syscall_id);

/* delete all rules for ALL syscalls */
int 
dev_file_del_all_rules(sct_ctrl_t ctrl);

/* print the current rules */
int
dev_file_print_all_rules(sct_ctrl_t ctrl);

int 
dev_file_do_protocol(sct_ctrl_t ctrl, unsigned int cmd, 
		     int rule_id, rule_when_t when, int syscall_id, 
		     unsigned char* buf, unsigned int length, 
		     int enable_rule);

#endif /* DEV_FILE_IMPL_H_ */
