/*
 *$Id: filter_vars_public.h,v 1.6 2001/12/08 09:24:39 amirs Exp $
 */
#ifndef _KERNEL_VARS_PUBLIC_H
#define _KERNEL_VARS_PUBLIC_H

#include "rule_engine_public.h"

/*
 * Kernal variables manipulation code.
 */

/* empty variable values array. */
void reset_all_vars(void);

/* callback function type */
typedef filter_node_t* (*callback_func)(var_type_t, void*);
typedef filter_node_t* (*callback_indexed_func)(var_type_t, int, data_type_t, void*);

/* store a given variable's value. */
void set_var(var_type_t type, filter_node_t* val);
void set_var_callback(var_type_t type, callback_func func, void* data);
void set_persistent_callback(var_type_t type, callback_func func, void* data);
void set_var_field(var_type_t type, int field_index, filter_node_t* val);
void set_var_indexed(var_type_t type, int var_index, filter_node_t* val);
void set_var_indexed_callback(var_type_t type, int var_index, callback_indexed_func func, data_type_t dtype, void* data);

/* evaluate the value of the given parameter, assuming it was previously */
/* set with set_var/set_var_index.                                       */
filter_node_t* get_var(var_type_t type);
filter_node_t* get_var_indexed(var_type_t type, int var_index);

#endif /* _KERNEL_VARS_PUBLIC_H */
