/*
 * $Id: request_buffer.h,v 1.1 2001/12/24 21:04:57 mulix Exp $
 */

#ifndef REQUEST_BUFFER_H_
#define REQUEST_BUFFER_H_

#include <linux/kernel.h>

#define RBUF_ORIG_BUF_SIZE 1024

struct request_buffer
{
    unsigned char* whead;
    unsigned char data[RBUF_ORIG_BUF_SIZE];
    size_t free_space;
    size_t data_size;
}; 

typedef struct request_buffer* req_buf_t;

/* add to the end of the request buffer this user supplied chunk,  */
/* with this size.  */
/* returns 0 on succes, a negative error on failure.  */
/* NOTE: chunk should point into user space memory, add_chunk will  */
/* take care of the copying */
int rbuf_add_chunk(req_buf_t buf, unsigned char* chunk, size_t sz);

/* does this request buffer contain a whole request packet */
int rbuf_has_whole_packet(req_buf_t buf);

/* get the request buffer's raw data */
unsigned char* rbuf_get_data(req_buf_t buf);

/* clear this request buffer */
void rbuf_clear(req_buf_t buf);

#endif /* REQUEST_BUFFER_H_ */
