/*
 * $Id: string_util.c,v 1.1 2001/12/20 04:18:04 mulix Exp $
 */

#include <linux/kernel.h>
#include <linux/slab.h>
#include <linux/errno.h>
#include <asm/uaccess.h>

#include "string_util.h"

/* get PAGE_SIZE memory (to copy a string into it, in our case) */
#define __getstring()     (char *)kmalloc(PAGE_SIZE, GFP_KERNEL) 

static inline int do_getstring(const char* str, char* page)
{
	int retval;
	unsigned long len = PATH_MAX + 1;

	if ((unsigned long) str >= TASK_SIZE) {
		if (!segment_eq(get_fs(), KERNEL_DS))
			return -EFAULT;
	} else if (TASK_SIZE - (unsigned long) str < PATH_MAX + 1)
		len = TASK_SIZE - (unsigned long) str;

	retval = strncpy_from_user((char *)page, str, len);
	if (retval > 0) {
		if (retval < len)
			return 0;
		return -ENAMETOOLONG;
	} else if (!retval) {
	        return -ENOENT;
	}

	return retval;
}


int getstring(const char* str, char** kern_str)
{
	int result;
	char *tmp;
	
	result = -ENOMEM;
	tmp = __getstring();
	if (tmp)  {
                if ((result = do_getstring(str, tmp)) < 0) {
                        putstring(tmp);
			*kern_str = NULL;
                } else {
			*kern_str = tmp;
		}
	}
        return result;
}
