/*
 * $Id: syscall_hijack_autogen.c,v 1.26 2001/12/20 04:18:04 mulix Exp $
 */

/* This file is automatically generated - do not edit. */
/* built by './gen_syscalls.pl 256' for Linux. */


#include <asm/errno.h>

#include <linux/types.h>
#include <linux/time.h>


/*
 * Stub functions for syscall hijacking.
 */

/* stub function for syscall 'open' (5). */
asmlinkage static int
stub_syscall_5(const char* pathname, int flags, mode_t mode) {
	typedef int
		(*stub_func_5)(const char* pathname, int flags, mode_t mode);
	typedef int
		(*stub_after_func_5)(int syscall_rc, const char* pathname, int flags, mode_t mode);
	stub_func_5 before_func;
	stub_after_func_5 after_func;
	stub_func_5 orig_syscall_func;
	int retval;
	int rc;
	struct syscall_hijack_data* hdata = &hijack_data[5];

	rc = down_interruptible(&hdata->sem);
	if (rc < 0)
		return rc;
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_func_5)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pathname, flags, mode)
		    : 0);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == 0) {
	    orig_syscall_func = (stub_func_5)hdata->orig_syscall;
	    retval =  (orig_syscall_func ? (*orig_syscall_func)(pathname, flags, mode) : -ENOSYS);

	    after_func = (stub_after_func_5)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(retval, pathname, flags, mode);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return retval;
}

/* stub function for syscall 'link' (9). */
asmlinkage static int
stub_syscall_9(const char* oldpath, const char* newpath) {
	typedef int
		(*stub_func_9)(const char* oldpath, const char* newpath);
	typedef int
		(*stub_after_func_9)(int syscall_rc, const char* oldpath, const char* newpath);
	stub_func_9 before_func;
	stub_after_func_9 after_func;
	stub_func_9 orig_syscall_func;
	int retval;
	int rc;
	struct syscall_hijack_data* hdata = &hijack_data[9];

	rc = down_interruptible(&hdata->sem);
	if (rc < 0)
		return rc;
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_func_9)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(oldpath, newpath)
		    : 0);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == 0) {
	    orig_syscall_func = (stub_func_9)hdata->orig_syscall;
	    retval =  (orig_syscall_func ? (*orig_syscall_func)(oldpath, newpath) : -ENOSYS);

	    after_func = (stub_after_func_9)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(retval, oldpath, newpath);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return retval;
}

/* stub function for syscall 'unlink' (10). */
asmlinkage static int
stub_syscall_10(const char* pathname) {
	typedef int
		(*stub_func_10)(const char* pathname);
	typedef int
		(*stub_after_func_10)(int syscall_rc, const char* pathname);
	stub_func_10 before_func;
	stub_after_func_10 after_func;
	stub_func_10 orig_syscall_func;
	int retval;
	int rc;
	struct syscall_hijack_data* hdata = &hijack_data[10];

	rc = down_interruptible(&hdata->sem);
	if (rc < 0)
		return rc;
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_func_10)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pathname)
		    : 0);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == 0) {
	    orig_syscall_func = (stub_func_10)hdata->orig_syscall;
	    retval =  (orig_syscall_func ? (*orig_syscall_func)(pathname) : -ENOSYS);

	    after_func = (stub_after_func_10)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(retval, pathname);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return retval;
}

/* stub function for syscall 'chdir' (12). */
asmlinkage static int
stub_syscall_12(const char* pathname) {
	typedef int
		(*stub_func_12)(const char* pathname);
	typedef int
		(*stub_after_func_12)(int syscall_rc, const char* pathname);
	stub_func_12 before_func;
	stub_after_func_12 after_func;
	stub_func_12 orig_syscall_func;
	int retval;
	int rc;
	struct syscall_hijack_data* hdata = &hijack_data[12];

	rc = down_interruptible(&hdata->sem);
	if (rc < 0)
		return rc;
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_func_12)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pathname)
		    : 0);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == 0) {
	    orig_syscall_func = (stub_func_12)hdata->orig_syscall;
	    retval =  (orig_syscall_func ? (*orig_syscall_func)(pathname) : -ENOSYS);

	    after_func = (stub_after_func_12)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(retval, pathname);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return retval;
}

/* stub function for syscall 'chmod' (15). */
asmlinkage static int
stub_syscall_15(const char* pathname, mode_t mode) {
	typedef int
		(*stub_func_15)(const char* pathname, mode_t mode);
	typedef int
		(*stub_after_func_15)(int syscall_rc, const char* pathname, mode_t mode);
	stub_func_15 before_func;
	stub_after_func_15 after_func;
	stub_func_15 orig_syscall_func;
	int retval;
	int rc;
	struct syscall_hijack_data* hdata = &hijack_data[15];

	rc = down_interruptible(&hdata->sem);
	if (rc < 0)
		return rc;
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_func_15)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pathname, mode)
		    : 0);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == 0) {
	    orig_syscall_func = (stub_func_15)hdata->orig_syscall;
	    retval =  (orig_syscall_func ? (*orig_syscall_func)(pathname, mode) : -ENOSYS);

	    after_func = (stub_after_func_15)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(retval, pathname, mode);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return retval;
}

/* stub function for syscall 'lseek' (19). */
asmlinkage static int
stub_syscall_19(int fildes, off_t offset, int whence) {
	typedef int
		(*stub_func_19)(int fildes, off_t offset, int whence);
	typedef int
		(*stub_after_func_19)(int syscall_rc, int fildes, off_t offset, int whence);
	stub_func_19 before_func;
	stub_after_func_19 after_func;
	stub_func_19 orig_syscall_func;
	int retval;
	int rc;
	struct syscall_hijack_data* hdata = &hijack_data[19];

	rc = down_interruptible(&hdata->sem);
	if (rc < 0)
		return rc;
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_func_19)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(fildes, offset, whence)
		    : 0);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == 0) {
	    orig_syscall_func = (stub_func_19)hdata->orig_syscall;
	    retval =  (orig_syscall_func ? (*orig_syscall_func)(fildes, offset, whence) : -ENOSYS);

	    after_func = (stub_after_func_19)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(retval, fildes, offset, whence);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return retval;
}

/* stub function for syscall 'getpid' (20). */
asmlinkage static int
stub_syscall_20(void) {
	typedef int
		(*stub_func_20)(void);
	typedef int
		(*stub_after_func_20)(int syscall_rc);
	stub_func_20 before_func;
	stub_after_func_20 after_func;
	stub_func_20 orig_syscall_func;
	int retval;
	int rc;
	struct syscall_hijack_data* hdata = &hijack_data[20];

	rc = down_interruptible(&hdata->sem);
	if (rc < 0)
		return rc;
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_func_20)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)()
		    : 0);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == 0) {
	    orig_syscall_func = (stub_func_20)hdata->orig_syscall;
	    retval =  (orig_syscall_func ? (*orig_syscall_func)() : -ENOSYS);

	    after_func = (stub_after_func_20)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(retval );
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return retval;
}

/* stub function for syscall 'access' (33). */
asmlinkage static int
stub_syscall_33(const char* pathname, int mode) {
	typedef int
		(*stub_func_33)(const char* pathname, int mode);
	typedef int
		(*stub_after_func_33)(int syscall_rc, const char* pathname, int mode);
	stub_func_33 before_func;
	stub_after_func_33 after_func;
	stub_func_33 orig_syscall_func;
	int retval;
	int rc;
	struct syscall_hijack_data* hdata = &hijack_data[33];

	rc = down_interruptible(&hdata->sem);
	if (rc < 0)
		return rc;
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_func_33)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pathname, mode)
		    : 0);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == 0) {
	    orig_syscall_func = (stub_func_33)hdata->orig_syscall;
	    retval =  (orig_syscall_func ? (*orig_syscall_func)(pathname, mode) : -ENOSYS);

	    after_func = (stub_after_func_33)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(retval, pathname, mode);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return retval;
}

/* stub function for syscall 'nice' (34). */
asmlinkage static int
stub_syscall_34(int inc) {
	typedef int
		(*stub_func_34)(int inc);
	typedef int
		(*stub_after_func_34)(int syscall_rc, int inc);
	stub_func_34 before_func;
	stub_after_func_34 after_func;
	stub_func_34 orig_syscall_func;
	int retval;
	int rc;
	struct syscall_hijack_data* hdata = &hijack_data[34];

	rc = down_interruptible(&hdata->sem);
	if (rc < 0)
		return rc;
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_func_34)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(inc)
		    : 0);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == 0) {
	    orig_syscall_func = (stub_func_34)hdata->orig_syscall;
	    retval =  (orig_syscall_func ? (*orig_syscall_func)(inc) : -ENOSYS);

	    after_func = (stub_after_func_34)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(retval, inc);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return retval;
}

/* stub function for syscall 'kill' (37). */
asmlinkage static int
stub_syscall_37(pid_t pid, int sig) {
	typedef int
		(*stub_func_37)(pid_t pid, int sig);
	typedef int
		(*stub_after_func_37)(int syscall_rc, pid_t pid, int sig);
	stub_func_37 before_func;
	stub_after_func_37 after_func;
	stub_func_37 orig_syscall_func;
	int retval;
	int rc;
	struct syscall_hijack_data* hdata = &hijack_data[37];

	rc = down_interruptible(&hdata->sem);
	if (rc < 0)
		return rc;
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_func_37)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pid, sig)
		    : 0);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == 0) {
	    orig_syscall_func = (stub_func_37)hdata->orig_syscall;
	    retval =  (orig_syscall_func ? (*orig_syscall_func)(pid, sig) : -ENOSYS);

	    after_func = (stub_after_func_37)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(retval, pid, sig);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return retval;
}

/* stub function for syscall 'rename' (38). */
asmlinkage static int
stub_syscall_38(const char* oldpath, const char* newpath) {
	typedef int
		(*stub_func_38)(const char* oldpath, const char* newpath);
	typedef int
		(*stub_after_func_38)(int syscall_rc, const char* oldpath, const char* newpath);
	stub_func_38 before_func;
	stub_after_func_38 after_func;
	stub_func_38 orig_syscall_func;
	int retval;
	int rc;
	struct syscall_hijack_data* hdata = &hijack_data[38];

	rc = down_interruptible(&hdata->sem);
	if (rc < 0)
		return rc;
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_func_38)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(oldpath, newpath)
		    : 0);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == 0) {
	    orig_syscall_func = (stub_func_38)hdata->orig_syscall;
	    retval =  (orig_syscall_func ? (*orig_syscall_func)(oldpath, newpath) : -ENOSYS);

	    after_func = (stub_after_func_38)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(retval, oldpath, newpath);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return retval;
}

/* stub function for syscall 'mkdir' (39). */
asmlinkage static int
stub_syscall_39(const char* pathname, mode_t mode) {
	typedef int
		(*stub_func_39)(const char* pathname, mode_t mode);
	typedef int
		(*stub_after_func_39)(int syscall_rc, const char* pathname, mode_t mode);
	stub_func_39 before_func;
	stub_after_func_39 after_func;
	stub_func_39 orig_syscall_func;
	int retval;
	int rc;
	struct syscall_hijack_data* hdata = &hijack_data[39];

	rc = down_interruptible(&hdata->sem);
	if (rc < 0)
		return rc;
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_func_39)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pathname, mode)
		    : 0);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == 0) {
	    orig_syscall_func = (stub_func_39)hdata->orig_syscall;
	    retval =  (orig_syscall_func ? (*orig_syscall_func)(pathname, mode) : -ENOSYS);

	    after_func = (stub_after_func_39)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(retval, pathname, mode);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return retval;
}

/* stub function for syscall 'rmdir' (40). */
asmlinkage static int
stub_syscall_40(const char* pathname) {
	typedef int
		(*stub_func_40)(const char* pathname);
	typedef int
		(*stub_after_func_40)(int syscall_rc, const char* pathname);
	stub_func_40 before_func;
	stub_after_func_40 after_func;
	stub_func_40 orig_syscall_func;
	int retval;
	int rc;
	struct syscall_hijack_data* hdata = &hijack_data[40];

	rc = down_interruptible(&hdata->sem);
	if (rc < 0)
		return rc;
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_func_40)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pathname)
		    : 0);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == 0) {
	    orig_syscall_func = (stub_func_40)hdata->orig_syscall;
	    retval =  (orig_syscall_func ? (*orig_syscall_func)(pathname) : -ENOSYS);

	    after_func = (stub_after_func_40)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(retval, pathname);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return retval;
}

/* stub function for syscall 'dup' (41). */
asmlinkage static int
stub_syscall_41(int oldfd) {
	typedef int
		(*stub_func_41)(int oldfd);
	typedef int
		(*stub_after_func_41)(int syscall_rc, int oldfd);
	stub_func_41 before_func;
	stub_after_func_41 after_func;
	stub_func_41 orig_syscall_func;
	int retval;
	int rc;
	struct syscall_hijack_data* hdata = &hijack_data[41];

	rc = down_interruptible(&hdata->sem);
	if (rc < 0)
		return rc;
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_func_41)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(oldfd)
		    : 0);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == 0) {
	    orig_syscall_func = (stub_func_41)hdata->orig_syscall;
	    retval =  (orig_syscall_func ? (*orig_syscall_func)(oldfd) : -ENOSYS);

	    after_func = (stub_after_func_41)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(retval, oldfd);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return retval;
}

/* stub function for syscall 'chroot' (61). */
asmlinkage static int
stub_syscall_61(const char* path) {
	typedef int
		(*stub_func_61)(const char* path);
	typedef int
		(*stub_after_func_61)(int syscall_rc, const char* path);
	stub_func_61 before_func;
	stub_after_func_61 after_func;
	stub_func_61 orig_syscall_func;
	int retval;
	int rc;
	struct syscall_hijack_data* hdata = &hijack_data[61];

	rc = down_interruptible(&hdata->sem);
	if (rc < 0)
		return rc;
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_func_61)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(path)
		    : 0);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == 0) {
	    orig_syscall_func = (stub_func_61)hdata->orig_syscall;
	    retval =  (orig_syscall_func ? (*orig_syscall_func)(path) : -ENOSYS);

	    after_func = (stub_after_func_61)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(retval, path);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return retval;
}

/* stub function for syscall 'dup2' (63). */
asmlinkage static int
stub_syscall_63(int oldfd, int newfd) {
	typedef int
		(*stub_func_63)(int oldfd, int newfd);
	typedef int
		(*stub_after_func_63)(int syscall_rc, int oldfd, int newfd);
	stub_func_63 before_func;
	stub_after_func_63 after_func;
	stub_func_63 orig_syscall_func;
	int retval;
	int rc;
	struct syscall_hijack_data* hdata = &hijack_data[63];

	rc = down_interruptible(&hdata->sem);
	if (rc < 0)
		return rc;
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_func_63)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(oldfd, newfd)
		    : 0);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == 0) {
	    orig_syscall_func = (stub_func_63)hdata->orig_syscall;
	    retval =  (orig_syscall_func ? (*orig_syscall_func)(oldfd, newfd) : -ENOSYS);

	    after_func = (stub_after_func_63)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(retval, oldfd, newfd);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return retval;
}

/* stub function for syscall 'symlink' (83). */
asmlinkage static int
stub_syscall_83(const char* oldpath, const char* newpath) {
	typedef int
		(*stub_func_83)(const char* oldpath, const char* newpath);
	typedef int
		(*stub_after_func_83)(int syscall_rc, const char* oldpath, const char* newpath);
	stub_func_83 before_func;
	stub_after_func_83 after_func;
	stub_func_83 orig_syscall_func;
	int retval;
	int rc;
	struct syscall_hijack_data* hdata = &hijack_data[83];

	rc = down_interruptible(&hdata->sem);
	if (rc < 0)
		return rc;
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_func_83)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(oldpath, newpath)
		    : 0);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == 0) {
	    orig_syscall_func = (stub_func_83)hdata->orig_syscall;
	    retval =  (orig_syscall_func ? (*orig_syscall_func)(oldpath, newpath) : -ENOSYS);

	    after_func = (stub_after_func_83)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(retval, oldpath, newpath);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return retval;
}

/* stub function for syscall 'settimeofday' (79). */
asmlinkage static int
stub_syscall_79(const struct timeval* tv, struct timezone* tz) {
	typedef int
		(*stub_func_79)(const struct timeval* tv, struct timezone* tz);
	typedef int
		(*stub_after_func_79)(int syscall_rc, const struct timeval* tv, struct timezone* tz);
	stub_func_79 before_func;
	stub_after_func_79 after_func;
	stub_func_79 orig_syscall_func;
	int retval;
	int rc;
	struct syscall_hijack_data* hdata = &hijack_data[79];

	rc = down_interruptible(&hdata->sem);
	if (rc < 0)
		return rc;
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_func_79)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(tv, tz)
		    : 0);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == 0) {
	    orig_syscall_func = (stub_func_79)hdata->orig_syscall;
	    retval =  (orig_syscall_func ? (*orig_syscall_func)(tv, tz) : -ENOSYS);

	    after_func = (stub_after_func_79)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(retval, tv, tz);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return retval;
}

/* stub function for syscall 'getpriority' (96). */
asmlinkage static int
stub_syscall_96(int which, int who) {
	typedef int
		(*stub_func_96)(int which, int who);
	typedef int
		(*stub_after_func_96)(int syscall_rc, int which, int who);
	stub_func_96 before_func;
	stub_after_func_96 after_func;
	stub_func_96 orig_syscall_func;
	int retval;
	int rc;
	struct syscall_hijack_data* hdata = &hijack_data[96];

	rc = down_interruptible(&hdata->sem);
	if (rc < 0)
		return rc;
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_func_96)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(which, who)
		    : 0);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == 0) {
	    orig_syscall_func = (stub_func_96)hdata->orig_syscall;
	    retval =  (orig_syscall_func ? (*orig_syscall_func)(which, who) : -ENOSYS);

	    after_func = (stub_after_func_96)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(retval, which, who);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return retval;
}

/* stub function for syscall 'setpriority' (97). */
asmlinkage static int
stub_syscall_97(int which, int who, int pro) {
	typedef int
		(*stub_func_97)(int which, int who, int pro);
	typedef int
		(*stub_after_func_97)(int syscall_rc, int which, int who, int pro);
	stub_func_97 before_func;
	stub_after_func_97 after_func;
	stub_func_97 orig_syscall_func;
	int retval;
	int rc;
	struct syscall_hijack_data* hdata = &hijack_data[97];

	rc = down_interruptible(&hdata->sem);
	if (rc < 0)
		return rc;
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_func_97)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(which, who, pro)
		    : 0);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == 0) {
	    orig_syscall_func = (stub_func_97)hdata->orig_syscall;
	    retval =  (orig_syscall_func ? (*orig_syscall_func)(which, who, pro) : -ENOSYS);

	    after_func = (stub_after_func_97)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(retval, which, who, pro);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return retval;
}

/* stub function for syscall 'setuid' (213). */
asmlinkage static int
stub_syscall_213(uid_t uid) {
	typedef int
		(*stub_func_213)(uid_t uid);
	typedef int
		(*stub_after_func_213)(int syscall_rc, uid_t uid);
	stub_func_213 before_func;
	stub_after_func_213 after_func;
	stub_func_213 orig_syscall_func;
	int retval;
	int rc;
	struct syscall_hijack_data* hdata = &hijack_data[213];

	rc = down_interruptible(&hdata->sem);
	if (rc < 0)
		return rc;
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_func_213)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(uid)
		    : 0);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == 0) {
	    orig_syscall_func = (stub_func_213)hdata->orig_syscall;
	    retval =  (orig_syscall_func ? (*orig_syscall_func)(uid) : -ENOSYS);

	    after_func = (stub_after_func_213)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(retval, uid);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return retval;
}

/* stub function for syscall 'socketcall' (102). */
asmlinkage static int
stub_syscall_102(int call, unsigned long* args) {
	typedef int
		(*stub_func_102)(int call, unsigned long* args);
	typedef int
		(*stub_after_func_102)(int syscall_rc, int call, unsigned long* args);
	stub_func_102 before_func;
	stub_after_func_102 after_func;
	stub_func_102 orig_syscall_func;
	int retval;
	int rc;
	struct syscall_hijack_data* hdata = &hijack_data[102];

	rc = down_interruptible(&hdata->sem);
	if (rc < 0)
		return rc;
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_func_102)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(call, args)
		    : 0);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == 0) {
	    orig_syscall_func = (stub_func_102)hdata->orig_syscall;
	    retval =  (orig_syscall_func ? (*orig_syscall_func)(call, args) : -ENOSYS);

	    after_func = (stub_after_func_102)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(retval, call, args);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return retval;
}


/* pointers to stub functions - to be used */
/* when hijacking system calls.            */
func_ptr stub_functions[] = {
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_5,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_9,
	(func_ptr)stub_syscall_10,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_12,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_15,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_19,
	(func_ptr)stub_syscall_20,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_33,
	(func_ptr)stub_syscall_34,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_37,
	(func_ptr)stub_syscall_38,
	(func_ptr)stub_syscall_39,
	(func_ptr)stub_syscall_40,
	(func_ptr)stub_syscall_41,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_61,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_63,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_79,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_83,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_96,
	(func_ptr)stub_syscall_97,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_102,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_213,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
};
