/*
 * $Id: syscall_tracker_autogen.c,v 1.26 2001/12/20 04:18:04 mulix Exp $
 */

/* This file is automatically generated - do not edit. */
/* built by './gen_syscalls.pl 256' for Linux. */


#include <asm/errno.h>

#include "var_callbacks.h"

/*
 * struct-offsets evaluation functions for dynamic type-casting.
 */

/* calculate offsets of fields for struct 'timeval'. */
static long*
make_struct_offsets_vec_timeval(long* num_fields)
{
	struct timeval s;
	char* base = (char*)&s;
        long* offsets_vec =
	    (long*)kmalloc(sizeof(unsigned long) * 2, GFP_KERNEL);
  
	if (offsets_vec) {
		offsets_vec[0] = (long)( ((char*)&s.tv_sec) - base);
		offsets_vec[1] = (long)( ((char*)&s.tv_usec) - base);

	}

	*num_fields = 2;

	return offsets_vec;
}

/* calculate offsets of fields for struct 'timezone'. */
static long*
make_struct_offsets_vec_timezone(long* num_fields)
{
	struct timezone s;
	char* base = (char*)&s;
        long* offsets_vec =
	    (long*)kmalloc(sizeof(unsigned long) * 2, GFP_KERNEL);
  
	if (offsets_vec) {
		offsets_vec[0] = (long)( ((char*)&s.tz_minuteswest) - base);
		offsets_vec[1] = (long)( ((char*)&s.tz_dsttime) - base);

	}

	*num_fields = 2;

	return offsets_vec;
}

/* calculate offsets of fields for struct 'sockaddr'. */
static long*
make_struct_offsets_vec_sockaddr(long* num_fields)
{
	struct sockaddr s;
	char* base = (char*)&s;
        long* offsets_vec =
	    (long*)kmalloc(sizeof(unsigned long) * 2, GFP_KERNEL);
  
	if (offsets_vec) {
		offsets_vec[0] = (long)( ((char*)&s.sa_family) - base);
		offsets_vec[1] = -1;

	}

	*num_fields = 2;

	return offsets_vec;
}

/*
 * Tracking functions for syscall hijacking.
 */

/* tracking function for syscall 'open' (5). */
asmlinkage static int
track_before_syscall_5(const char* pathname, int flags, mode_t mode) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_STRING, (void*)pathname);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_INT, (void*)&flags);
		action = filter_syscall(track_data[5].before_rules,
					5,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[5].before_rules,
			action, rule_id, 5, "open",
			"P i uh" , 0, flags, mode);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'open' (5). */
asmlinkage static int
track_after_syscall_5(int syscall_rc, const char* pathname, int flags, mode_t mode) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_STRING, (void*)pathname);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_INT, (void*)&flags);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(track_data[5].after_rules,
					5,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[5].after_rules,
			action, rule_id, 5, "open",
			"P i uh" , 0, flags, mode);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'link' (9). */
asmlinkage static int
track_before_syscall_9(const char* oldpath, const char* newpath) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_STRING, (void*)oldpath);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_STRING, (void*)newpath);
		action = filter_syscall(track_data[9].before_rules,
					9,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[9].before_rules,
			action, rule_id, 9, "link",
			"P P" , 0, 1);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'link' (9). */
asmlinkage static int
track_after_syscall_9(int syscall_rc, const char* oldpath, const char* newpath) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_STRING, (void*)oldpath);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_STRING, (void*)newpath);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(track_data[9].after_rules,
					9,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[9].after_rules,
			action, rule_id, 9, "link",
			"P P" , 0, 1);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'unlink' (10). */
asmlinkage static int
track_before_syscall_10(const char* pathname) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_STRING, (void*)pathname);
		action = filter_syscall(track_data[10].before_rules,
					10,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[10].before_rules,
			action, rule_id, 10, "unlink",
			"P" , 0);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'unlink' (10). */
asmlinkage static int
track_after_syscall_10(int syscall_rc, const char* pathname) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_STRING, (void*)pathname);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(track_data[10].after_rules,
					10,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[10].after_rules,
			action, rule_id, 10, "unlink",
			"P" , 0);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'chdir' (12). */
asmlinkage static int
track_before_syscall_12(const char* pathname) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_STRING, (void*)pathname);
		action = filter_syscall(track_data[12].before_rules,
					12,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[12].before_rules,
			action, rule_id, 12, "chdir",
			"P" , 0);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'chdir' (12). */
asmlinkage static int
track_after_syscall_12(int syscall_rc, const char* pathname) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_STRING, (void*)pathname);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(track_data[12].after_rules,
					12,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[12].after_rules,
			action, rule_id, 12, "chdir",
			"P" , 0);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'chmod' (15). */
asmlinkage static int
track_before_syscall_15(const char* pathname, mode_t mode) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_STRING, (void*)pathname);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_USHORT, (void*)&mode);
		action = filter_syscall(track_data[15].before_rules,
					15,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[15].before_rules,
			action, rule_id, 15, "chmod",
			"P uh" , 0, mode);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'chmod' (15). */
asmlinkage static int
track_after_syscall_15(int syscall_rc, const char* pathname, mode_t mode) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_STRING, (void*)pathname);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_USHORT, (void*)&mode);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(track_data[15].after_rules,
					15,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[15].after_rules,
			action, rule_id, 15, "chmod",
			"P uh" , 0, mode);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'lseek' (19). */
asmlinkage static int
track_before_syscall_19(int fildes, off_t offset, int whence) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&fildes);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_LONG, (void*)&offset);
		set_var_indexed_callback(VT_PARAM, 2, global_param_callback, DT_INT, (void*)&whence);
		action = filter_syscall(track_data[19].before_rules,
					19,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[19].before_rules,
			action, rule_id, 19, "lseek",
			"i l i" , fildes, offset, whence);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'lseek' (19). */
asmlinkage static int
track_after_syscall_19(int syscall_rc, int fildes, off_t offset, int whence) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&fildes);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_LONG, (void*)&offset);
		set_var_indexed_callback(VT_PARAM, 2, global_param_callback, DT_INT, (void*)&whence);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(track_data[19].after_rules,
					19,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[19].after_rules,
			action, rule_id, 19, "lseek",
			"i l i" , fildes, offset, whence);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'getpid' (20). */
asmlinkage static int
track_before_syscall_20(void) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		action = filter_syscall(track_data[20].before_rules,
					20,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[20].before_rules,
			action, rule_id, 20, "getpid",
			"v" );
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'getpid' (20). */
asmlinkage static int
track_after_syscall_20(int syscall_rc) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(track_data[20].after_rules,
					20,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[20].after_rules,
			action, rule_id, 20, "getpid",
			"v" );
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'access' (33). */
asmlinkage static int
track_before_syscall_33(const char* pathname, int mode) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_STRING, (void*)pathname);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_INT, (void*)&mode);
		action = filter_syscall(track_data[33].before_rules,
					33,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[33].before_rules,
			action, rule_id, 33, "access",
			"P i" , 0, mode);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'access' (33). */
asmlinkage static int
track_after_syscall_33(int syscall_rc, const char* pathname, int mode) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_STRING, (void*)pathname);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_INT, (void*)&mode);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(track_data[33].after_rules,
					33,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[33].after_rules,
			action, rule_id, 33, "access",
			"P i" , 0, mode);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'nice' (34). */
asmlinkage static int
track_before_syscall_34(int inc) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&inc);
		action = filter_syscall(track_data[34].before_rules,
					34,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[34].before_rules,
			action, rule_id, 34, "nice",
			"i" , inc);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'nice' (34). */
asmlinkage static int
track_after_syscall_34(int syscall_rc, int inc) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&inc);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(track_data[34].after_rules,
					34,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[34].after_rules,
			action, rule_id, 34, "nice",
			"i" , inc);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'kill' (37). */
asmlinkage static int
track_before_syscall_37(pid_t pid, int sig) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&pid);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_INT, (void*)&sig);
		action = filter_syscall(track_data[37].before_rules,
					37,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[37].before_rules,
			action, rule_id, 37, "kill",
			"i i" , pid, sig);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'kill' (37). */
asmlinkage static int
track_after_syscall_37(int syscall_rc, pid_t pid, int sig) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&pid);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_INT, (void*)&sig);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(track_data[37].after_rules,
					37,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[37].after_rules,
			action, rule_id, 37, "kill",
			"i i" , pid, sig);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'rename' (38). */
asmlinkage static int
track_before_syscall_38(const char* oldpath, const char* newpath) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_STRING, (void*)oldpath);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_STRING, (void*)newpath);
		action = filter_syscall(track_data[38].before_rules,
					38,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[38].before_rules,
			action, rule_id, 38, "rename",
			"P P" , 0, 1);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'rename' (38). */
asmlinkage static int
track_after_syscall_38(int syscall_rc, const char* oldpath, const char* newpath) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_STRING, (void*)oldpath);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_STRING, (void*)newpath);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(track_data[38].after_rules,
					38,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[38].after_rules,
			action, rule_id, 38, "rename",
			"P P" , 0, 1);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'mkdir' (39). */
asmlinkage static int
track_before_syscall_39(const char* pathname, mode_t mode) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_STRING, (void*)pathname);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_USHORT, (void*)&mode);
		action = filter_syscall(track_data[39].before_rules,
					39,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[39].before_rules,
			action, rule_id, 39, "mkdir",
			"P uh" , 0, mode);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'mkdir' (39). */
asmlinkage static int
track_after_syscall_39(int syscall_rc, const char* pathname, mode_t mode) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_STRING, (void*)pathname);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_USHORT, (void*)&mode);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(track_data[39].after_rules,
					39,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[39].after_rules,
			action, rule_id, 39, "mkdir",
			"P uh" , 0, mode);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'rmdir' (40). */
asmlinkage static int
track_before_syscall_40(const char* pathname) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_STRING, (void*)pathname);
		action = filter_syscall(track_data[40].before_rules,
					40,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[40].before_rules,
			action, rule_id, 40, "rmdir",
			"P" , 0);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'rmdir' (40). */
asmlinkage static int
track_after_syscall_40(int syscall_rc, const char* pathname) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_STRING, (void*)pathname);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(track_data[40].after_rules,
					40,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[40].after_rules,
			action, rule_id, 40, "rmdir",
			"P" , 0);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'dup' (41). */
asmlinkage static int
track_before_syscall_41(int oldfd) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&oldfd);
		action = filter_syscall(track_data[41].before_rules,
					41,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[41].before_rules,
			action, rule_id, 41, "dup",
			"i" , oldfd);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'dup' (41). */
asmlinkage static int
track_after_syscall_41(int syscall_rc, int oldfd) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&oldfd);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(track_data[41].after_rules,
					41,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[41].after_rules,
			action, rule_id, 41, "dup",
			"i" , oldfd);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'chroot' (61). */
asmlinkage static int
track_before_syscall_61(const char* path) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_STRING, (void*)path);
		action = filter_syscall(track_data[61].before_rules,
					61,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[61].before_rules,
			action, rule_id, 61, "chroot",
			"P" , 0);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'chroot' (61). */
asmlinkage static int
track_after_syscall_61(int syscall_rc, const char* path) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_STRING, (void*)path);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(track_data[61].after_rules,
					61,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[61].after_rules,
			action, rule_id, 61, "chroot",
			"P" , 0);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'dup2' (63). */
asmlinkage static int
track_before_syscall_63(int oldfd, int newfd) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&oldfd);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_INT, (void*)&newfd);
		action = filter_syscall(track_data[63].before_rules,
					63,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[63].before_rules,
			action, rule_id, 63, "dup2",
			"i i" , oldfd, newfd);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'dup2' (63). */
asmlinkage static int
track_after_syscall_63(int syscall_rc, int oldfd, int newfd) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&oldfd);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_INT, (void*)&newfd);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(track_data[63].after_rules,
					63,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[63].after_rules,
			action, rule_id, 63, "dup2",
			"i i" , oldfd, newfd);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'symlink' (83). */
asmlinkage static int
track_before_syscall_83(const char* oldpath, const char* newpath) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_STRING, (void*)oldpath);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_STRING, (void*)newpath);
		action = filter_syscall(track_data[83].before_rules,
					83,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[83].before_rules,
			action, rule_id, 83, "symlink",
			"P P" , 0, 1);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'symlink' (83). */
asmlinkage static int
track_after_syscall_83(int syscall_rc, const char* oldpath, const char* newpath) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_STRING, (void*)oldpath);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_STRING, (void*)newpath);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(track_data[83].after_rules,
					83,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[83].after_rules,
			action, rule_id, 83, "symlink",
			"P P" , 0, 1);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'settimeofday' (79). */
asmlinkage static int
track_before_syscall_79(const struct timeval* tv, struct timezone* tz) {
	struct timeval kern_tv;
	struct timezone kern_tz;
	long retval = 0;

	if (tv) {
		if (copy_from_user(&kern_tv, tv, sizeof(kern_tv))) {
			retval = -EFAULT;
			goto tracker_79_failed;
		}
	}
	if (tz) {
		if (copy_from_user(&kern_tz, tz, sizeof(kern_tz))) {
			retval = -EFAULT;
			goto tracker_79_failed;
		}
	}

	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* param0 = make_filter_vector(2);
		filter_node_t* param1 = make_filter_vector(2);
		if (tv) {
			insert_filter_node(param0, 0, make_long_val(kern_tv.tv_sec));
			insert_filter_node(param0, 1, make_long_val(kern_tv.tv_usec));
		}
		if (tz) {
			insert_filter_node(param1, 0, make_int_val(kern_tz.tz_minuteswest));
			insert_filter_node(param1, 1, make_int_val(kern_tz.tz_dsttime));
		}

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			free_filter_node(param0);
			free_filter_node(param1);
			goto tracker_79_failed;
		}
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var_indexed(VT_PARAM, 1, param1);
		action = filter_syscall(track_data[79].before_rules,
					79,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[79].before_rules,
			action, rule_id, 79, "settimeofday",
			"S{l l} S{i i}" , "timeval", tv, (tv ? kern_tv.tv_sec : 0L), (tv ? kern_tv.tv_usec : 0L), "timezone", tz, (tz ? kern_tz.tz_minuteswest : 0), (tz ? kern_tz.tz_dsttime : 0));
		}
		up(&tracker_sem);
	}

  tracker_79_failed:

	return retval;
}

/* tracking function for syscall 'settimeofday' (79). */
asmlinkage static int
track_after_syscall_79(int syscall_rc, const struct timeval* tv, struct timezone* tz) {
	struct timeval kern_tv;
	struct timezone kern_tz;
	long retval = 0;

	if (tv) {
		if (copy_from_user(&kern_tv, tv, sizeof(kern_tv))) {
			retval = -EFAULT;
			goto tracker_79_failed;
		}
	}
	if (tz) {
		if (copy_from_user(&kern_tz, tz, sizeof(kern_tz))) {
			retval = -EFAULT;
			goto tracker_79_failed;
		}
	}

	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* param0 = make_filter_vector(2);
		filter_node_t* param1 = make_filter_vector(2);
		if (tv) {
			insert_filter_node(param0, 0, make_long_val(kern_tv.tv_sec));
			insert_filter_node(param0, 1, make_long_val(kern_tv.tv_usec));
		}
		if (tz) {
			insert_filter_node(param1, 0, make_int_val(kern_tz.tz_minuteswest));
			insert_filter_node(param1, 1, make_int_val(kern_tz.tz_dsttime));
		}

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			free_filter_node(param0);
			free_filter_node(param1);
			goto tracker_79_failed;
		}
		reset_all_vars();
		set_var_indexed(VT_PARAM, 0, param0);
		set_var_indexed(VT_PARAM, 1, param1);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(track_data[79].after_rules,
					79,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[79].after_rules,
			action, rule_id, 79, "settimeofday",
			"S{l l} S{i i}" , "timeval", tv, (tv ? kern_tv.tv_sec : 0L), (tv ? kern_tv.tv_usec : 0L), "timezone", tz, (tz ? kern_tz.tz_minuteswest : 0), (tz ? kern_tz.tz_dsttime : 0));
		}
		up(&tracker_sem);
	}

  tracker_79_failed:

	return retval;
}

/* tracking function for syscall 'getpriority' (96). */
asmlinkage static int
track_before_syscall_96(int which, int who) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&which);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_INT, (void*)&who);
		action = filter_syscall(track_data[96].before_rules,
					96,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[96].before_rules,
			action, rule_id, 96, "getpriority",
			"i i" , which, who);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'getpriority' (96). */
asmlinkage static int
track_after_syscall_96(int syscall_rc, int which, int who) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&which);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_INT, (void*)&who);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(track_data[96].after_rules,
					96,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[96].after_rules,
			action, rule_id, 96, "getpriority",
			"i i" , which, who);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'setpriority' (97). */
asmlinkage static int
track_before_syscall_97(int which, int who, int pro) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&which);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_INT, (void*)&who);
		set_var_indexed_callback(VT_PARAM, 2, global_param_callback, DT_INT, (void*)&pro);
		action = filter_syscall(track_data[97].before_rules,
					97,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[97].before_rules,
			action, rule_id, 97, "setpriority",
			"i i i" , which, who, pro);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'setpriority' (97). */
asmlinkage static int
track_after_syscall_97(int syscall_rc, int which, int who, int pro) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&which);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_INT, (void*)&who);
		set_var_indexed_callback(VT_PARAM, 2, global_param_callback, DT_INT, (void*)&pro);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(track_data[97].after_rules,
					97,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[97].after_rules,
			action, rule_id, 97, "setpriority",
			"i i i" , which, who, pro);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'setuid' (213). */
asmlinkage static int
track_before_syscall_213(uid_t uid) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_SHORT, (void*)&uid);
		action = filter_syscall(track_data[213].before_rules,
					213,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[213].before_rules,
			action, rule_id, 213, "setuid",
			"uh" , uid);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'setuid' (213). */
asmlinkage static int
track_after_syscall_213(int syscall_rc, uid_t uid) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_SHORT, (void*)&uid);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(track_data[213].after_rules,
					213,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[213].after_rules,
			action, rule_id, 213, "setuid",
			"uh" , uid);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'socketcall' (102). */
asmlinkage static int
track_before_syscall_102(int call, unsigned long* args) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&call);
		action = filter_syscall(track_data[102].before_rules,
					102,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[102].before_rules,
			action, rule_id, 102, "socketcall",
			"i p" , call, args);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'socketcall' (102). */
asmlinkage static int
track_after_syscall_102(int syscall_rc, int call, unsigned long* args) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0) 
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&call);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(track_data[102].after_rules,
					102,
					&rule_id);
		if (action) {
			tracker_perform_action(track_data[102].after_rules,
			action, rule_id, 102, "socketcall",
			"i p" , call, args);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'socket' (102:1). */
asmlinkage static int
track_before_syscall_102_1(int family, int type, int protocol) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0)
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&family);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_INT, (void*)&type);
		set_var_indexed_callback(VT_PARAM, 2, global_param_callback, DT_INT, (void*)&protocol);
		action = filter_syscall(mux_data[mux_data_index(102)].before_rules[1], 102, &rule_id);
		if (action) {
			tracker_perform_action(mux_data[mux_data_index(102)].before_rules[1],
			action, rule_id, 102, "socket",
			"i i i" , family, type, protocol);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'socket' (102:1). */
asmlinkage static int
track_after_syscall_102_1(int syscall_rc, int family, int type, int protocol) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0)
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&family);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_INT, (void*)&type);
		set_var_indexed_callback(VT_PARAM, 2, global_param_callback, DT_INT, (void*)&protocol);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(mux_data[mux_data_index(102)].after_rules[1], 102, &rule_id);
		if (action) {
			tracker_perform_action(mux_data[mux_data_index(102)].after_rules[1],
			action, rule_id, 102, "socket",
			"i i i" , family, type, protocol);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'bind' (102:2). */
asmlinkage static int
track_before_syscall_102_2(int sockfd, struct sockaddr* my_addr, int addrlen) {
	struct sockaddr kern_my_addr;
	long retval = 0;

	if (my_addr) {
		if (copy_from_user(&kern_my_addr, my_addr, sizeof(kern_my_addr))) {
			retval = -EFAULT;
			goto tracker_102_failed;
		}
	}

	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* param1 = make_filter_vector(2);
		if (my_addr) {
			insert_filter_node(param1, 0, make_ushort_val(kern_my_addr.sa_family));
		}

		retval = down_interruptible(&tracker_sem);
		if (retval < 0)
		{
			free_filter_node(param1);
			goto tracker_102_failed;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&sockfd);
		set_var_indexed(VT_PARAM, 1, param1);
		set_var_indexed_callback(VT_PARAM, 2, global_param_callback, DT_INT, (void*)&addrlen);
		action = filter_syscall(mux_data[mux_data_index(102)].before_rules[2], 102, &rule_id);
		if (action) {
			tracker_perform_action(mux_data[mux_data_index(102)].before_rules[2],
			action, rule_id, 102, "bind",
			"i S{uh p} i" , sockfd, "sockaddr", my_addr, (my_addr ? kern_my_addr.sa_family : 0), (my_addr ? kern_my_addr.sa_data : '\0'), addrlen);
		}
		up(&tracker_sem);
	}

  tracker_102_failed:

	return retval;
}

/* tracking function for syscall 'bind' (102:2). */
asmlinkage static int
track_after_syscall_102_2(int syscall_rc, int sockfd, struct sockaddr* my_addr, int addrlen) {
	struct sockaddr kern_my_addr;
	long retval = 0;

	if (my_addr) {
		if (copy_from_user(&kern_my_addr, my_addr, sizeof(kern_my_addr))) {
			retval = -EFAULT;
			goto tracker_102_failed;
		}
	}

	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* param1 = make_filter_vector(2);
		if (my_addr) {
			insert_filter_node(param1, 0, make_ushort_val(kern_my_addr.sa_family));
		}

		retval = down_interruptible(&tracker_sem);
		if (retval < 0)
		{
			free_filter_node(param1);
			goto tracker_102_failed;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&sockfd);
		set_var_indexed(VT_PARAM, 1, param1);
		set_var_indexed_callback(VT_PARAM, 2, global_param_callback, DT_INT, (void*)&addrlen);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(mux_data[mux_data_index(102)].after_rules[2], 102, &rule_id);
		if (action) {
			tracker_perform_action(mux_data[mux_data_index(102)].after_rules[2],
			action, rule_id, 102, "bind",
			"i S{uh p} i" , sockfd, "sockaddr", my_addr, (my_addr ? kern_my_addr.sa_family : 0), (my_addr ? kern_my_addr.sa_data : '\0'), addrlen);
		}
		up(&tracker_sem);
	}

  tracker_102_failed:

	return retval;
}

/* tracking function for syscall 'connect' (102:3). */
asmlinkage static int
track_before_syscall_102_3(int fd, const struct sockaddr* addr, int addrlen) {
	struct sockaddr kern_addr;
	long retval = 0;

	if (addr) {
		if (copy_from_user(&kern_addr, addr, sizeof(kern_addr))) {
			retval = -EFAULT;
			goto tracker_102_failed;
		}
	}

	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* param1 = make_filter_vector(2);
		if (addr) {
			insert_filter_node(param1, 0, make_ushort_val(kern_addr.sa_family));
		}

		retval = down_interruptible(&tracker_sem);
		if (retval < 0)
		{
			free_filter_node(param1);
			goto tracker_102_failed;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&fd);
		set_var_indexed(VT_PARAM, 1, param1);
		set_var_indexed_callback(VT_PARAM, 2, global_param_callback, DT_INT, (void*)&addrlen);
		action = filter_syscall(mux_data[mux_data_index(102)].before_rules[3], 102, &rule_id);
		if (action) {
			tracker_perform_action(mux_data[mux_data_index(102)].before_rules[3],
			action, rule_id, 102, "connect",
			"i S{uh p} i" , fd, "sockaddr", addr, (addr ? kern_addr.sa_family : 0), (addr ? kern_addr.sa_data : '\0'), addrlen);
		}
		up(&tracker_sem);
	}

  tracker_102_failed:

	return retval;
}

/* tracking function for syscall 'connect' (102:3). */
asmlinkage static int
track_after_syscall_102_3(int syscall_rc, int fd, const struct sockaddr* addr, int addrlen) {
	struct sockaddr kern_addr;
	long retval = 0;

	if (addr) {
		if (copy_from_user(&kern_addr, addr, sizeof(kern_addr))) {
			retval = -EFAULT;
			goto tracker_102_failed;
		}
	}

	{
		action_t* action = NULL;
		int rule_id = -1;
		filter_node_t* param1 = make_filter_vector(2);
		if (addr) {
			insert_filter_node(param1, 0, make_ushort_val(kern_addr.sa_family));
		}

		retval = down_interruptible(&tracker_sem);
		if (retval < 0)
		{
			free_filter_node(param1);
			goto tracker_102_failed;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&fd);
		set_var_indexed(VT_PARAM, 1, param1);
		set_var_indexed_callback(VT_PARAM, 2, global_param_callback, DT_INT, (void*)&addrlen);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(mux_data[mux_data_index(102)].after_rules[3], 102, &rule_id);
		if (action) {
			tracker_perform_action(mux_data[mux_data_index(102)].after_rules[3],
			action, rule_id, 102, "connect",
			"i S{uh p} i" , fd, "sockaddr", addr, (addr ? kern_addr.sa_family : 0), (addr ? kern_addr.sa_data : '\0'), addrlen);
		}
		up(&tracker_sem);
	}

  tracker_102_failed:

	return retval;
}

/* tracking function for syscall 'listen' (102:4). */
asmlinkage static int
track_before_syscall_102_4(int fd, int backlog) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0)
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&fd);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_INT, (void*)&backlog);
		action = filter_syscall(mux_data[mux_data_index(102)].before_rules[4], 102, &rule_id);
		if (action) {
			tracker_perform_action(mux_data[mux_data_index(102)].before_rules[4],
			action, rule_id, 102, "listen",
			"i i" , fd, backlog);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'listen' (102:4). */
asmlinkage static int
track_after_syscall_102_4(int syscall_rc, int fd, int backlog) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0)
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&fd);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_INT, (void*)&backlog);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(mux_data[mux_data_index(102)].after_rules[4], 102, &rule_id);
		if (action) {
			tracker_perform_action(mux_data[mux_data_index(102)].after_rules[4],
			action, rule_id, 102, "listen",
			"i i" , fd, backlog);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'accept' (102:5). */
asmlinkage static int
track_before_syscall_102_5(int fd, struct sockaddr* addr, int* addrlen) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0)
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&fd);
		action = filter_syscall(mux_data[mux_data_index(102)].before_rules[5], 102, &rule_id);
		if (action) {
			tracker_perform_action(mux_data[mux_data_index(102)].before_rules[5],
			action, rule_id, 102, "accept",
			"i p p" , fd, "sockaddr", addr, addrlen);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'accept' (102:5). */
asmlinkage static int
track_after_syscall_102_5(int syscall_rc, int fd, struct sockaddr* addr, int* addrlen) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0)
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&fd);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(mux_data[mux_data_index(102)].after_rules[5], 102, &rule_id);
		if (action) {
			tracker_perform_action(mux_data[mux_data_index(102)].after_rules[5],
			action, rule_id, 102, "accept",
			"i p p" , fd, "sockaddr", addr, addrlen);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'shutdown' (102:13). */
asmlinkage static int
track_before_syscall_102_13(int fd, int how) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0)
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&fd);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_INT, (void*)&how);
		action = filter_syscall(mux_data[mux_data_index(102)].before_rules[13], 102, &rule_id);
		if (action) {
			tracker_perform_action(mux_data[mux_data_index(102)].before_rules[13],
			action, rule_id, 102, "shutdown",
			"i i" , fd, how);
		}
		up(&tracker_sem);
	}


	return retval;
}

/* tracking function for syscall 'shutdown' (102:13). */
asmlinkage static int
track_after_syscall_102_13(int syscall_rc, int fd, int how) {
	long retval = 0;


	{
		action_t* action = NULL;
		int rule_id = -1;

		retval = down_interruptible(&tracker_sem);
		if (retval < 0)
		{
			return retval;
		}
		reset_all_vars();
		set_var_indexed_callback(VT_PARAM, 0, global_param_callback, DT_INT, (void*)&fd);
		set_var_indexed_callback(VT_PARAM, 1, global_param_callback, DT_INT, (void*)&how);
		set_var_callback(VT_RETVAL, global_retval_callback, (void*)syscall_rc);
		action = filter_syscall(mux_data[mux_data_index(102)].after_rules[13], 102, &rule_id);
		if (action) {
			tracker_perform_action(mux_data[mux_data_index(102)].after_rules[13],
			action, rule_id, 102, "shutdown",
			"i i" , fd, how);
		}
		up(&tracker_sem);
	}


	return retval;
}


void
init_mux_functions(void)
{
	/* init for mux syscall '102'. */
	init_mux_function(102, 1, (func_ptr)track_before_syscall_102_1, (func_ptr)track_after_syscall_102_1);
	init_mux_function(102, 2, (func_ptr)track_before_syscall_102_2, (func_ptr)track_after_syscall_102_2);
	init_mux_function(102, 3, (func_ptr)track_before_syscall_102_3, (func_ptr)track_after_syscall_102_3);
	init_mux_function(102, 4, (func_ptr)track_before_syscall_102_4, (func_ptr)track_after_syscall_102_4);
	init_mux_function(102, 5, (func_ptr)track_before_syscall_102_5, (func_ptr)track_after_syscall_102_5);
	init_mux_function(102, 13, (func_ptr)track_before_syscall_102_13, (func_ptr)track_after_syscall_102_13);

}

/* array of struct fields offsets - to be used when extracting struct fields. */
struct struct_data struct_type_data[3];

/* initialization of structs_type_data array. */
void
init_struct_offsets(void)
{
	long num_fields;
        long* offsets_vec;
  
	offsets_vec = make_struct_offsets_vec_timeval(&num_fields);
	struct_type_data[0].offsets_vec = offsets_vec;
	struct_type_data[0].num_fields = num_fields;
	offsets_vec = make_struct_offsets_vec_sockaddr(&num_fields);
	struct_type_data[1].offsets_vec = offsets_vec;
	struct_type_data[1].num_fields = num_fields;
	offsets_vec = make_struct_offsets_vec_timezone(&num_fields);
	struct_type_data[2].offsets_vec = offsets_vec;
	struct_type_data[2].num_fields = num_fields;

}

/* pointers to 'before' stub functions - to be used */
/* when hijacking system calls.                     */
func_ptr before_track_functions[] = {
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_before_syscall_5,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_before_syscall_9,
	(func_ptr)track_before_syscall_10,
	(func_ptr)NULL,
	(func_ptr)track_before_syscall_12,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_before_syscall_15,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_before_syscall_19,
	(func_ptr)track_before_syscall_20,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_before_syscall_33,
	(func_ptr)track_before_syscall_34,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_before_syscall_37,
	(func_ptr)track_before_syscall_38,
	(func_ptr)track_before_syscall_39,
	(func_ptr)track_before_syscall_40,
	(func_ptr)track_before_syscall_41,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_before_syscall_61,
	(func_ptr)NULL,
	(func_ptr)track_before_syscall_63,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_before_syscall_79,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_before_syscall_83,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_before_syscall_96,
	(func_ptr)track_before_syscall_97,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_before_syscall_102,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_before_syscall_213,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
};

/* pointers to 'after' stub functions - to be used */
/* when hijacking system calls.                     */
func_ptr after_track_functions[] = {
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_after_syscall_5,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_after_syscall_9,
	(func_ptr)track_after_syscall_10,
	(func_ptr)NULL,
	(func_ptr)track_after_syscall_12,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_after_syscall_15,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_after_syscall_19,
	(func_ptr)track_after_syscall_20,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_after_syscall_33,
	(func_ptr)track_after_syscall_34,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_after_syscall_37,
	(func_ptr)track_after_syscall_38,
	(func_ptr)track_after_syscall_39,
	(func_ptr)track_after_syscall_40,
	(func_ptr)track_after_syscall_41,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_after_syscall_61,
	(func_ptr)NULL,
	(func_ptr)track_after_syscall_63,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_after_syscall_79,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_after_syscall_83,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_after_syscall_96,
	(func_ptr)track_after_syscall_97,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_after_syscall_102,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)track_after_syscall_213,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
};
