/*
 * $Id: tracker_sysctl.h,v 1.1 2001/12/20 04:18:04 mulix Exp $
 */

#ifndef TRACKER_SYSCTL_H_
#define TRACKER_SYSCTL_H_

#include "sct_rules_private.h"
#include "rule_engine_public.h"

int tracker_sysctl_add_rule(int rule_id,
			    rule_when_t when,
			    int syscall_id,
			    int mux_func_id,
			    filter_node_t* f,
			    action_t* a);

int tracker_sysctl_del_rule(int rule_id,
			    rule_when_t when,
			    int syscall_id,
			    int mux_func_id);

/* deletes all existing rules for a given system call. */
/* TODO - handle muxed functions as if they were real syscalls. */
int tracker_sysctl_del_all_rules_for_syscall(int syscall_id, int mux_func_id);

/* deletes all existing rules in the module */
int tracker_sysctl_del_all_module_rules(void);

/* prints all existing rules in the module */
int tracker_sysctl_print_all_rules(void);

#endif /* TRACKER_SYSCTL_H_ */


