#! /usr/bin/env python

#
# $Id: compile_test.py,v 1.3 2001/10/02 17:40:09 mulix Exp $
#

import sys
import os
import string
import re

def compile(c_compiler, cpp_compiler, kernel_dir):
    """
    run 'make_all' in the current directory, using the given
    compilers and setting KERNEL_DIR to 'kernel_dir'
    """
    os.system('./clean_all > /dev/null')
    command = './make_all'
    #params need a dummy parameter, because execvp swallows it. no idea why
    params = ['dummy', 'GXX='+cpp_compiler, 'CC='+c_compiler, 'KERNEL_DIR='+kernel_dir]
    print '\n\ncompiling with: ', command, params, '\n\n'
    sys.stdout.flush()
    rc = os.fork()
    if rc == 0:
        rc = os.execvp(command, params)
        _exit(rc)
    rc = os.wait()
    return rc[1]

if __name__ == "__main__":

    compilers_file = open('tests/compilers.dat', "r")
    kernel_dirs_file = open('tests/kernel_dirs.dat', "r")

    compilers = [string.strip(z) for z in compilers_file.readlines()]
    kernel_dirs = [string.strip(z) for z in kernel_dirs_file.readlines()]

    regexp = re.compile("^#|^ ")

    for c in compilers:
        if regexp.match(c):
            continue
        for k in kernel_dirs:
            if regexp.match(k):
                continue
            rc = compile(c+'gcc', c+'g++', k)
            if (rc != 0):
                print '\n\n\ncompilation failed with ',c,'gcc KERNEL_DIR=',k,'\n\n'
                sys.stdout.flush()
                
