/*
 * $Id: sct_rules_tests.c,v 1.4 2001/12/09 20:30:41 chooga Exp $
 */
#include <stdio.h>
#include <sys/time.h>
#include <unistd.h>

#include "sct_rules/rule_engine_public.h"
#include "sct_rules/filter_vars_public.h"

#include "tester.h"

/* NOTE: this file is a complete mess, a simple copy and paste job 
   from sct_rules/main.c. it needs to be rearranged, extended and 
   cleaned up. it has memory leaks. it sucks. but it's a start */

/* filter evaluation testing */
int
test_filter_eval_bit(void)
{
    filter_node_t* result = make_bool_val(TF_FALSE);
    exp_error_t rc;
    
    {
	filter_node_t* f0 = make_long_val(120L);
	filter_node_t* f1 = make_long_val(30L);
	filter_node_t* f2 = make_bit_and(f0, f1);
	
	printf("\n");
	printf("Evaluating filter:\n");
	print_filter_node(f2);
	printf("eval_filter_node returned '%d'\n", rc);
	rc = eval_filter_node(f2, result);
	if (rc != ERR_NONE) {
	    return 0;
	}
	printf("result:\n");
	print_filter_node(result);
	printf("\n");
		free_filter_node(f2);
    }
    {
	filter_node_t* f0 = make_long_val(120L);
	filter_node_t* f1 = make_long_val(30L);
	filter_node_t* f2 = make_bit_or(f0, f1);
	
	printf("\n");
	printf("Evaluating filter:\n");
	print_filter_node(f2);
	rc = eval_filter_node(f2, result);
	printf("eval_filter_node returned '%d'\n", rc);
	if (rc != ERR_NONE) {
	    return 0;
	}
	printf("result:\n");
	print_filter_node(result);
	printf("\n");
	free_filter_node(f2);
    }
    {
	filter_node_t* f0 = make_long_val(120L);
	filter_node_t* f1 = make_long_val(30L);
	filter_node_t* f2 = make_bit_xor(f0, f1);
	
	printf("\n");
	printf("Evaluating filter:\n");
	print_filter_node(f2);
	rc = eval_filter_node(f2, result);
	printf("eval_filter_node returned '%d'\n", rc);
	if (rc != ERR_NONE) {
	    return 0;
	}
	printf("result:\n");
	print_filter_node(result);
	printf("\n");
	free_filter_node(f2);
    }
    
    free_filter_node(result);
    return 1;
}

filter_node_t* get_a_filter_expression(void)
{
    filter_node_t* f0 = make_string_val("hello world");
    filter_node_t* f1 = make_string_val("lo w");
    filter_node_t* f2 = make_pattern_match(f0, f1);
    filter_node_t* f3 = make_int_val(15);
    filter_node_t* f4 = make_logical_and(f2, f3);
    return f4;
}

int 
test_eval_complex_filter(void)
{
    struct timeval t1, t2;
    filter_node_t* result = make_bool_val(TF_FALSE);
    exp_error_t rc;
    filter_node_t* f4 = get_a_filter_expression();
    
    printf("Printing filter node.\n");
    print_filter_node(f4);
    
    gettimeofday(&t1, NULL);
    rc = eval_filter_node(f4, result);
    gettimeofday(&t2, NULL);
    
    printf("   time before eval: %ld, %ld\n", t1.tv_sec, t1.tv_usec);
    printf("   time after  eval: %ld, %ld\n", t2.tv_sec, t2.tv_usec);
    printf("Expression result (rc = %d):\n", rc);
    print_filter_node(result);
    free_filter_node(f4);
    free_filter_node(result);
    return 1;
    
}

/* filter serialization/deserializatin testing. */
int
test_filter_serialize_deserialize(void)
{
    unsigned char buf[1000];
    filter_node_t* f4 = get_a_filter_expression();
    int len = serialize_filter_node(f4, buf, 1000);
    int rc = 0; /* assume failure */
    printf("serialized 'f4' into '%d' bytes\n", len);
    
    if (len > 0) {
	filter_node_t* f_deser =
	    deserialize_filter_node(buf, len);
	if (f_deser) {
	    printf("'f4' deserialized:\n");
	    print_filter_node(f_deser);
	    free_filter_node(f_deser);
	    rc = 1;
	}
	else {
	    printf("Deserialization of 'f4' failed.\n");
	}
    }
    return rc;
}


	/* tracking rules serialization/de-serialization testing. */
int
test_rules_serialize_deserialize(void)
{
    unsigned char buf[1000];
    action_t* a1 = make_action_log(4, NULL);
    filter_node_t* f4 = get_a_filter_expression();
    int len = serialize_tracking_rule(1, RW_BEFORE, 10, a1, f4, buf, 1000);
    int rc = 0;
    printf("serialized rule 1 into '%d' bytes\n", len);
    
    if (len > 0) {
	action_t* a_deser;
	filter_node_t* f_deser;
	int rule_id;
	rule_when_t when;
	int syscall_id;
	int res = deserialize_tracking_rule(buf,
					   len,
					   &rule_id,
					   &when,
					   &syscall_id,
					   &a_deser,
					   &f_deser);
	if (res > 0) {
	    printf("rule 1 deserialized:\n");
	    printf(" rule_id - %d\n", rule_id);
	    printf(" when - %d (%s)\n",
		   when, (when == RW_BEFORE ? "before" : "after"));
	    printf(" syscall_id - %d\n", syscall_id);
	    print_action_node(a_deser);
	    print_filter_node(f_deser);
	    free_filter_node(f_deser);
	    rc = 1;
	}
	else {
	    printf("Deserialization of rule 1 failed.\n");
	}
    }
    return rc;
}

/* tracking rules add/delete testing. */
int 
test_tracking_rule_add_delete(void)
{
    rule_list_t* rules;
    action_t* a1 = make_action_log(4, NULL);
    action_t* a2 = make_action_disable_rule(6);
    filter_node_t* f4 = get_a_filter_expression();
    filter_node_t* f5 = get_a_filter_expression();
    int rc = 0;
    
    printf("creating tracking rules list\n");
    rules = create_tracking_rule_list();
    printf("adding tracking rules\n");
    rc = add_tracking_rule(rules, 6, f4, a1);
    rc = add_tracking_rule(rules, 3, f5, a2);
    
    print_tracking_rules(rules);
    
    printf("deleting all tracking rules\n");
    del_all_tracking_rules_in_list(rules);
    print_tracking_rules(rules);
    delete_tracking_rule_list(rules);

    return 1;
}

/* kernel variables assignment testing. */
int
test_kernel_variables(void)
{
    exp_error_t res;
    filter_node_t* v_sys_id = make_int_val(10);
    filter_node_t* v_param_0 = make_string_val("/etc/passwd");
    filter_node_t* f0 = make_var_val(VT_SYSCALL_ID, DT_INT);
    filter_node_t* f1 =
	make_var_indexed_val(VT_PARAM, 0, DT_STRING);
    filter_node_t* result = make_bool_val(TF_FALSE);
    
    reset_all_vars();
    set_var(VT_SYSCALL_ID, v_sys_id);
    set_var_indexed(VT_PARAM, 0, v_param_0);
    
    res = eval_filter_node(f0, result);
    printf("syscall_id (%d):\n", res);
    print_filter_node(result);
    
    res = eval_filter_node(f1, result);
    printf("param 0 (%d):\n", res);
    print_filter_node(result);
    return 1;
}

/* check short circuiting */
int 
test_short_circuiting(void)
{
    int rc;
    filter_node_t* f0 = make_int_val(1);
    filter_node_t* f1 = make_int_val(0);
    filter_node_t* f_and = make_logical_and(f0, f1);
    filter_node_t* f_or = make_logical_or(f0, f1);
    filter_node_t* result = make_bool_val(TF_FALSE);
    
    printf("-------------------\n");
    rc = eval_filter_node(f_and, result);
    
    printf("short circuiting support test: and - '%d'\n",rc);
    print_filter_node(result);
 	
    rc = eval_filter_node(f_or, result);
    printf("short circuiting support test: or - '%d'\n",rc);
    print_filter_node(result);
    free_filter_node(result);
    free_filter_node(f_and);
    
    return 1;
}

int 
test_indexed_field_variables(void)
{
    filter_node_t* result = make_bool_val(TF_FALSE);
    exp_error_t rc;
    
    printf("\n\n\n-------------------\n");
    printf("Testing variables\n");
    {
	filter_node_t* v_param_0 = make_filter_vector(2);
	filter_node_t* f0 = make_string_val("/bli/bla");
	filter_node_t* f1 = make_int_val(7);
	filter_node_t* filter_0_0 =
			make_var_indexed_field_val(VT_PARAM, 0, 0, DT_STRING);
	filter_node_t* filter_0_1 =
	    make_var_indexed_field_val(VT_PARAM, 0, 1, DT_STRING);
	insert_filter_node(v_param_0, 0, f0);
	insert_filter_node(v_param_0, 1, f1);
	
	reset_all_vars();
	set_var_indexed(VT_PARAM, 0, v_param_0);
	
	rc = eval_filter_node(filter_0_0, result);
	printf("param 0.0 (%d):\n", rc);
	print_filter_node(result);

	rc = eval_filter_node(filter_0_1, result);
	printf("param 0.1 (%d):\n", rc);
	print_filter_node(result);
	
	free_filter_node(filter_0_0);
	free_filter_node(filter_0_1);
    }

    free_filter_node(result);

    return 1;
}

/* test filter node vectors. */
int
test_filter_node_vectors(void)
{
    printf("\n\n\n");
    printf("Testing filter node vectors\n\n");
    
    {
	int rc;
	filter_node_t* f0 = make_ulong_val(120L);
	filter_node_t* f1 = make_ulong_val(30L);
	filter_node_t* f2 = make_math_plus(f0, f1);
	filter_node_t* f3 = make_bool_val(0);
	filter_node_t* f4 = make_int_val(10);
	filter_node_t* f5 = make_int_val(20);
	filter_node_t* f6 = make_equal(f4, f5);
	filter_node_t* vec = make_filter_vector(5);
	
	rc = insert_filter_node(vec, 0, f2);
	rc = insert_filter_node(vec, 1, f3);
	rc = insert_filter_node(vec, 2, f6);
	
	print_filter_node(vec);
	
	free_filter_node(vec);
    }
    printf("\n\n\n");

    return 1;
}

